SuperStrict
 
Import brl.DirectSoundAudio
 
' Types
Global SAMPLE:TSample = New TSample
Global QUEUE:TSamplequeue = New TSamplequeue
 
' Sound Globals
Global CHANNEL:TChannel = AllocChannel()
Global SAMPLEMAP:TMap = CreateMap()
Global SAMPLEQUEUE:TList = CreateList()
Global VOLUME:Int = 50
 
Graphics 800, 600
 
' Load and add Samples to TMap
SAMPLE.AddSample(LoadSound("test/Welcome Commander.ogg"), "WELCOME")
SAMPLE.AddSample(LoadSound("test/Scan completed.ogg"), "COMPLETE")
SAMPLE.AddSample(LoadSound("test/Terraformable.ogg"), "TERRAFORM")
 
While Not AppTerminate()
 
        Cls
       
        If KeyHit(KEY_ESCAPE) Then End
       
        ' Add Samples to Queue
        If KeyHit(KEY_1) Then QUEUE.AddQueue("WELCOME")
        If KeyHit(KEY_2) Then QUEUE.AddQueue("COMPLETE")
        If KeyHit(KEY_3) Then QUEUE.AddQueue("TERRAFORM")
 
        If KeyHit(KEY_SPACE) Then QUEUE.PlaySample("WELCOME")
       
        ' queue handling, check for objects and play them one by one
        QUEUE.PlayQueue()
       
        ' output survey
        DrawText "Elements in Queue: " + SAMPLEQUEUE.count(), 0, 0
        Local i:Int = 0
        For Local s:TSampleQueue = EachIn SAMPLEQUEUE
       
                If i = 0 Then
               
                        DrawText "Playing Sample: " + s.SAMPLE.desc, 0, 15
                       
                Else
                               
                        DrawText "Queued Sample #" + i + ": " + s.SAMPLE.desc, 0, 15 + (i * 15)
                       
                EndIf
               
                i:+1
       
        Next
       
        Flip
       
Wend
 
End
 
' ----------------------------------------------------------------------------
' Single Sample
' ----------------------------------------------------------------------------
Type TSample
 
        Field sound:TSound
        Field desc:String
       
        Method AddSample(sound:TSound, desc:String)
       
                Local s:TSample = New TSample
                s.sound = sound
                s.desc = desc
               
                MapInsert(SAMPLEMAP, desc, s)
       
        End Method
 
End Type
 
 
' ----------------------------------------------------------------------------
' Queued Sample Type
' ----------------------------------------------------------------------------
Type TSampleQueue
 
        Field sample:TSample
        Field active:Int
               
 
        ' ----------------------------------------------------------------------------
        ' Adds a sample to the Sample playing Queue
        ' ----------------------------------------------------------------------------
        Method AddQueue(desc:String)
       
                Local sample:TSample = TSample(MapValueForKey(SAMPLEMAP, desc))
               
                If TSample(sample) Then
               
                        Local s:TSampleQueue = New TSampleQueue
                        s.sample = sample
                       
                        ListAddLast(SAMPLEQUEUE, s)
                       
                        Print "Sample added to Queue: " + desc
                       
                EndIf
       
        End Method
               
        ' ----------------------------------------------------------------------------
        ' Plays the Sample Queue
        ' ----------------------------------------------------------------------------
        Method PlayQueue()
       
                For Local s:TSampleQueue = EachIn SAMPLEQUEUE
                               
                        If TSample(s.sample) Then
               
                                If (Not ChannelPlaying(CHANNEL)) And s.active = False Then
                               
                                        s.active = True
                                        PlayQueueSample(s.sample)
                                       
                                Else If (Not ChannelPlaying(CHANNEL)) And s.active = True Then
                               
                                        ListRemove(SAMPLEQUEUE, s)
                                        s = Null
               
                                EndIf
                               
                        EndIf
                       
                Next
       
        End Method
 
 
        ' ----------------------------------------------------------------------------
        ' plays a single sample on demand, instanteneous
        ' ----------------------------------------------------------------------------
        Method PlaySample(desc:String)
       
                Local s:TSample = TSample(MapValueForKey(SAMPLEMAP, desc))
               
                If TSample(s) Then
               
                        Print "Play Single Sample: " + desc
               
                        If ChannelPlaying(CHANNEL) Then StopChannel(CHANNEL)
                       
                        CHANNEL = CueSound(s.sound)
                       
                        ' set channelvolume
                        SetChannelVolume(CHANNEL, VOLUME / 100.0)
                        ResumeChannel CHANNEL
                       
                EndIf
                       
        End Method
 
               
               
        ' ----------------------------------------------------------------------------
        ' plays a single queue sample
        ' ----------------------------------------------------------------------------
        Method PlayQueueSample(s:TSample)
       
                Print "Play Queue Sample: " + s.desc
               
                If ChannelPlaying(CHANNEL) Then StopChannel(CHANNEL)
               
                CHANNEL = CueSound(s.sound)
               
                ' set channelvolume
                SetChannelVolume(CHANNEL, VOLUME / 100.0)
                ResumeChannel CHANNEL
               
        End Method
               
End Type